import java.util.Random;
import java.math.*;

public class Merges 
{
	
	public static int permutaciones=0;
	public static int [][] posibilidades;
	static int[] inicial;
	
	public Merges (int n){//metemos todas las posibles permutaciones de n numeros en 
		posibilidades=new int[n+1][factorial(n)];//en el "fondo"esta el numero de veces que se repite
		inicial=new int[n];
		for(int i=1;i<=n;i++){
			inicial[i-1]=i;
		}
		perm(inicial,0,inicial.length);
	}
	
	public static int factorial(int n){
		int res=1;
		for(int i=n;i>0;i--){
			res=res*i;
		}
		return res;
	}
	
	public void show(int n){
		for(int i=0;i<factorial(n);i++){
			for(int e=0;e<n;e++){
				System.out.print(posibilidades[e][i]);
			}
			System.out.println("-"+posibilidades[n][i]);
			//System.out.println("   "+i);
		}
	}
	
	static void perm (int v[],int i, int n) {
		int j = 0;	
		int k = 0;
		int l = 0;
		 
		if (i == n) {
			for(int e=0;e<v.length;e++){
				posibilidades[e][permutaciones]=v[e];
			}
			posibilidades[v.length][permutaciones]=0;
			permutaciones++;
		} else
			for (j=i; j<n; j++) {
				swap (v, i, j);
				perm (v, i+1, n);
				swap (v, i, j);
			}
	}
	
	static void swap (int v[], int i, int j) {
		int	t;
		t = v[i];
		v[i] = v[j];
		v[j] = t;
	}
	
	public static int [] mergeN3(int n){//n es tamao de la permutacion que se va a generar, tiene los numero de 1 a n
		int[][] triple=new int[3][n];//ii todo el metodo
		for(int i=0;i<n;i++){
			triple[0][i]=i+1;
		}
				
		//mergin' generando n^3
		Random generador = new Random();
		for(int i=0;i<n;i++){
			int cota=(int)(Math.pow((double)n,3.0));
			triple[1][i]=generador.nextInt(cota);
		}
		
		//merging ordenando con isort
		int x,j;
		for(int i=0;i<n;i++){//algoritmo de isort
	    	x=triple[1][i];
	    	j=i-1;
	    	while(j>(-1)&& x<triple[2][j]){
	    		triple[2][j+1]=triple[2][j];
	    		j--;
	    	}
	    	triple[2][j+1]=x;
	    }
		
		//finalmente reemplazamos los numeros segun la correspondencia en las primeras dos filas
		for(int i=0;i<n;i++){
			int potencia=triple[1][i];
			int corresponde=triple[0][i];
			for(int e=0;e<n;e++){
				if(triple[2][e]==potencia){
					triple[2][e]=corresponde;
					e=n+1;
				}
			}
		}
		
		
		int [] permutaciones= new int[n];
		for(int i=0;i<n;i++){
			permutaciones[i]=triple[2][i];
		}
		return permutaciones;
		
	}
	
	public static int [] mergeSwapAllItems(int n){//n es tamao de la permutacion que se va a generar, tiene los numero de 1 a n
		int [] permutaciones = new int[n];//ii todo el metodo
		Random generador = new Random();
		for(int i=0;i<n;i++){
			permutaciones[i]=i+1;
		}
		
		for(int i=0;i<n;i++){
			int posicion=generador.nextInt(n);
			int temp=permutaciones[posicion];
			permutaciones[posicion]=permutaciones[i];
			permutaciones[i]=temp;
		}
		
		/*for(int i=0;i<n;i++){
			System.out.print(permutaciones[i]);
		}
		System.out.println();*/
		return permutaciones;
	}
	
	public static int [] mergeSwapFrontItems(int n){//n es tamao de la permutacion que se va a generar, tiene los numero de 1 a n
		int [] permutaciones = new int[n];//ii todo el metodo
		Random generador = new Random();
		for(int i=0;i<n;i++){
			permutaciones[i]=i+1;
		}
		
		for(int i=0;i<n;i++){
			int posicion=generador.nextInt(n);
			int temp=permutaciones[posicion];
			permutaciones[posicion]=permutaciones[i];
			permutaciones[i]=temp;
		}
		for(int i=(permutaciones.length-1);i>0;i--){
			int posicion=generador.nextInt(i);
			int temp=permutaciones[posicion];
			permutaciones[posicion]=permutaciones[i];
			permutaciones[i]=temp;
		}
		
		/*for(int i=0;i<n;i++){
			System.out.print(permutaciones[i]);
		}
		System.out.println();*/
		return permutaciones;
	}
	
	public static int [] riffleShuffle(int n){//n es tamao de la permutacion que se va a generar, tiene los numero de 1 a n
		int [] permutaciones = new int[n];//ii todo el metodo
		Random generador = new Random();
		int cuts=(int)((Math.log(n)/Math.log(2)))+1;//deberia ser floor
		for(int i=0;i<n;i++){
			permutaciones[i]=i+1;
		}
		
		for(int i=0;i<cuts;i++){
			int cutpoint=generador.nextInt(n);
			int[] temp=new int[n];
			int j=0;
				
			
			int encima=(n)-cutpoint;//es el numero de cartas arriba del punto de corte inclusive
			int debajo=cutpoint;//es el numero de cartas debajo del punto de corte 
						
			System.out.println("");
			int tope=0;
			if(encima>debajo){
				tope=encima;
			}else{
				tope=debajo;
			}
			int unterOderAuf=generador.nextInt(2);//decidimos como hacemos el shuffle, si primero la de arriba o la de abajo
			if(unterOderAuf==0){
			for(int e=0;e<tope;e++){
				if(e<debajo){
					temp[j]=permutaciones[e];
					j++;
				}
				if(e<encima){
					temp[j]=permutaciones[cutpoint+e];
					j++;
				}
			}
			}
			else{
				for(int e=0;e<tope;e++){
					if(e<encima){
						temp[j]=permutaciones[cutpoint+e];
						j++;
					}
					if(e<debajo){
						temp[j]=permutaciones[e];
						j++;
					}
				}
			}
			for(int e=0;e<n;e++){//volvemos a poner el arrelo
				permutaciones[e]=temp[e];
			}
		}
		return permutaciones;
		
	}
	
	public static void cuenta(int [] cadena){
		/*for(int i=0;i<cadena.length;i++){
			System.out.print(cadena[i]);
		}*/
		System.out.println();
		for(int i=0;i<factorial(cadena.length);i++){//barrimos columnas
			int matches=0;
			for(int e=0;e<cadena.length;e++){//barrimos filas
				if(cadena[e]==posibilidades[e][i]){
					matches++;
				}
				else{
					e=cadena.length;//sale del ciclo pa' que no pierda tiempo
				}
				//System.out.print(e);
			}
			//System.out.println(matches+""+cadena.length);
			if(matches==cadena.length){
				posibilidades[cadena.length][i]++;//contamos la coincidencia
				i=factorial(cadena.length)+1;//sale del ciclo pa' no perder tiempo
			}
		}
	}
	
	public static void generate(int metodo, int numero, int n){//numero es el numero de permutaciones que quiere
		// metodo =1 es mergeN^3, 2 es mergeSwapAllItems 3 es mergeSwapFrontItems 
		//4 es riffle shuffle
		if(metodo==1){
			for(int i=0;i<numero;i++){
				int [] temporal=mergeN3(n);
				cuenta(temporal);
			}
		}
		if(metodo==2){
			for(int i=0;i<numero;i++){
				int [] temporal=mergeSwapAllItems(n);
				cuenta(temporal);
			}
		}
		if(metodo==3){
			for(int i=0;i<numero;i++){
				int [] temporal=mergeSwapFrontItems (n);
				cuenta(temporal);
			}
		}
		if(metodo==4){
			for(int i=0;i<numero;i++){
				int [] temporal=riffleShuffle(n);
				cuenta(temporal);
			}
		}
		
	}
	
	public void reset(){//ii
		for(int e=0;e<posibilidades[0].length;e++){
			posibilidades[posibilidades.length-1][e]=0;
		}
	}
	
	
	public static void main(String args[]){
		//System.out.println(factorial(4));
		int n=4;
		Merges mimerge=new Merges(n);
		//mimerge.show(n);
		//mergeN3(n);
		System.out.print("inicio");
		mimerge.generate(4,5500,n);
		mimerge.show(n);
		mimerge.reset();
		mimerge.show(n);
	}
	
}
